<control-brand-select>

	<div class="brand-select">

		<a href="#" class="btn btn-primary btn-sm btn-block" title="Προσθέστε μάρκες στην αναζήτησή σας" onclick="{ open_popup }">επιλογή μάρκας</a>

		<ul class="brands">

			<li class="brand" each="{ item, index in state.items }">
				<a href="#" class="brand-name" onclick="{ change_item }">
					{ item.name }
				</a>
				<div class="brand-model" if="{ item.model }">
					{ item.model }
				</div>
				<a href="#" class="delete" onclick="{ delete_item }" title="αφαίρεση">&times;</a>
			</li>

		</ul>

	</div>


	<div class="popup-ovelray" id="brands-popup" style="display:none">
        <div class="popup-window popup-lg" if="{ state.show_popup }">
            <div class="popup-heading">
                <div class="title">Επιλογή μάρκας</div>
                <a href="#" class="close" onclick="{ close_popup }">&times;</a>
            </div>

            <div class="popup-body">
            	<div class="row">
            		<div class="col-md-5 col-xs-12">
            			<div class="form-group">
	            			<label>Μάρκα</label>
	            			<select class="form-control" data-ref="brand" onchange="{ load_models }">
	            				<option value="">επιλογή</option>
	            				<option each="{ brand in state.brands }" value="{ brand.id }" selected="{ state.brand && state.brand.id == brand.id }">{ brand.title }</option>
	            			</select>
	            		</div>
            		</div>
            		<div class="col-md-5 col-xs-12">
            			<div class="form-group">
            				<label>Μοντέλο</label>
            				<select class="form-control" data-ref="model">
            					<option value="">όλα τα μοντέλα</option>
            					<option each="{ model in state.models }" value="{ model }">{ model }</option>
            				</select>
            			</div>
            		</div>
            		<div class="col-md-2 col-xs-12">
            			<label>&nbsp;</label>
            			<a href="#" class="btn btn-primary btn-block" onclick="{ select_brand }">OK</a>
            		</div>
            	</div>
            </div>

            <loader-icon class="control-loader" if="{ state.loading }"></loader-icon>
        </div>
    </div>

	<script>
		this.state = {
			brands: [],
			models: [],

			items: [], // selected items
			brand: null, // brand to change

			show_popup: false,
			loading: false,
		}


		this.toggle_loader = value => {
			this.state.loading = value;
			this.update();
		}


		this.set_brands = brands => {
			this.state.brands = brands;
		}


		this.set_values = values => {
			if (values) {
				var values_array = values.split(",");
				console.log(values_array);
				if (values_array) {
					values_array.map ( item => {
						var array = item.split("_");
						if (array[0]) {
							var id = array[0];
							var model = array[1] ? array[1] : "";

							var brand = this.state.brands.find( x => x.id == id);
							if (brand) {
								this.add_item(brand, model);
							}
						}
					})
				}
			}
		}


		this.get_values = () => {
			return this.state.items;
		}


		this.get_values_str = () => {
			var result = "";
			this.state.items.map( item => {
				result+= (result ? "," : "") + item.id + (item.model ? "_" + item.model : "");
			});

			return result;
		}


		this.change_item = event => {
			event.preventDefault();

			this.state.brand = event.item.item;
			this.open_popup();
		}


		this.add_item = (new_brand, new_model) => {
			// check if brand and model allready exist
			var exist = false;
			this.state.items.map( item => {
				if (item.id == new_brand.id && item.model == new_model) {
					exist = true;
				}
			});

			if (!exist) {
				this.state.items.push({
					id: new_brand.id,
					name: new_brand.title,
					model: new_model,
				});
				this.update();
				this.set_controls();

				if (this.opts.onchangehandler) {
					this.opts.onchangehandler();
				}
			}
		}


		this.delete_item = event => {
			event.preventDefault();
			event.stopPropagation();

			this.state.items.splice(event.item.index, 1);
			this.set_controls();

			if (this.opts.onchangehandler) {
				this.opts.onchangehandler();
			}
		}


		this.clear = () => {
			this.state.items = [];
			if (this.opts.onchangehandler) {
				this.opts.onchangehandler();
			}
		}


		/* Brand popup handlers */

		this.open_popup = event => {
			if (typeof event !== 'undefined') {
				event.preventDefault();
			}

			var tag = this;
			$('#brands-popup').fadeIn('fast', function() {
	            tag.state.show_popup = true;                
	            tag.update();

	            if (tag.state.brand) {
	            	tag.update();
	            	tag.load_models();
	            }
	        });
		}


		this.close_popup = event => {
			if (typeof event !== 'undefined') {
				event.preventDefault();
			}

			var tag = this;
            $('#brands-popup').fadeOut('fast', function() {
            	tag.state.models = [];
                tag.state.show_popup = false;
                tag.state.brand = null;
	            tag.update();
            });
		}


		this.load_models = event => {
			if (typeof event === 'undefined') {
				var brand_id = this.state.brand.id;
			} else {
				brand_id = event.target.value;
			}
			console.log("load_models for: " + brand_id);

			if (brand_id) {
				var tag = this;
				request(
					'search/automoto_models',
					{
						brand: brand_id
					},
					function(result) {
						console.log("load_models");
						console.log(result);

						tag.state.models = result.models;

						tag.update();
					},
					null, this.toggle_loader
				);
			} else {
				this.state.models = [];
			}
		}


		this.select_brand = event => {
			event.preventDefault();

			var brand = this.state.brands.find( x => x.id == this.refs.brand.value);
			this.add_item(brand, this.refs.model.value);
			this.close_popup();
		}


		/* control display handlers */

		this.set_controls = () => {
			this.update();

			if (this.state.items.length) {
				// set item:hover events
				$('li.brand a.delete').hover(
					function() {
						$(this).closest('li').addClass("to-remove")
					}, function() {
						$(this).closest('li').removeClass("to-remove")
					}
				)
			}
		}


		this.on("mount", function() {
			this.set_controls();

			var tag = this;
            // close popup if click on popup overlay
            $('#brands-popup').on("click", function(event) {
                if ($(event.target).hasClass('popup-ovelray')) {
                	tag.close_popup();
                }
            });
		});
	</script>
</control-brand-select>